Ginkgo: gko::experimental::mpi::contiguous_type Class Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::experimental::mpi::contiguous_type Class Reference

A move-only wrapper for a contiguous MPI_Datatype. More...

`#include <ginkgo/core/base/mpi.hpp>`

## Public Member Functions
| contiguous_type (int count, MPI_Datatype old_type)
| Constructs a wrapper for a contiguous MPI_Datatype.
| contiguous_type ()
| Constructs empty wrapper with MPI_DATATYPE_NULL.
| contiguous_type (const contiguous_type &)=delete
| Disallow copying of wrapper type.
contiguous_type & | operator= (const contiguous_type &)=delete
| Disallow copying of wrapper type.
| contiguous_type (contiguous_type &&other) noexcept
| Move constructor, leaves other with MPI_DATATYPE_NULL.
contiguous_type & | operator= (contiguous_type &&other) noexcept
| Move assignment, leaves other with MPI_DATATYPE_NULL.
| ~contiguous_type ()
| Destructs object by freeing wrapped MPI_Datatype.
MPI_Datatype | get () const
| Access the underlying MPI_Datatype.

## Detailed Description

A move-only wrapper for a contiguous MPI_Datatype.

The underlying MPI_Datatype is automatically created and committed when an object of this type is constructed, and freed when it is destructed.

## Constructor & Destructor Documentation

## ◆ contiguous_type() [1/2]

gko::experimental::mpi::contiguous_type::contiguous_type | ( | int | count,
|  | MPI_Datatype | old_type )
| inline

Constructs a wrapper for a contiguous MPI_Datatype.

Parameters

  count | the number of old_type elements the new datatype contains.
  old_type | the MPI_Datatype that is contained.

Referenced by contiguous_type(), contiguous_type(), operator=(), and operator=().

## ◆ contiguous_type() [2/2]

gko::experimental::mpi::contiguous_type::contiguous_type | ( | contiguous_type && | other | ) |
| inlinenoexcept

Move constructor, leaves other with MPI_DATATYPE_NULL.

Parameters

  other | to be moved from object.

References contiguous_type().

## Member Function Documentation

## ◆ get()

MPI_Datatype gko::experimental::mpi::contiguous_type::get | ( |  | ) | const
| inline

Access the underlying MPI_Datatype.

Returns
  the underlying MPI_Datatype.

## ◆ operator=()

contiguous_type & gko::experimental::mpi::contiguous_type::operator= | ( | contiguous_type && | other | ) |
| inlinenoexcept

Move assignment, leaves other with MPI_DATATYPE_NULL.

Parameters

  other | to be moved from object.

Returns
  this object.

References contiguous_type().

The documentation for this class was generated from the following file:

- ginkgo/core/base/mpi.hpp